' Tesla Coil Tutor Program
' Internal Version 1.0F  9/11/88
' Public Release 1.0 - 2/20/89
' File TCOIL.BAS
' by Dr. James F. Corum, Kenneth L. Corum and Daniel J. Edwards
' Copyright 1987, 1988, Corum & Associates, Inc.
' All Rights Reserved
'
' Revison History
' TC11.BAS Includes better quartic root procedure
'          Has component value save and restore feature
' TC12.BAS
'          Speed up Vind(t) and R(t) computation
'          Save BPS in component values
' TC13.BAS
'          Fixed bug in Freq computation - (H1,2 used in G11,22 before H1,2 set)
'          Put Zoom mode in spectrum analyzer
'          Allow spectrum analyzer to plot deltas
' TC14.BAS
'          Corrections fm Jim on roots computation and reasonable values
' TC15.BAS
'          Fixed DW variable collision (DW in part1 is now DW12)
'          Put QP, QS, FreqPri, K and Kc on 1st diagram
'          Use line drawing chars on 1st and 2nd diagram
'          K, Kc and QS on 1st diagram incomplete
' TC16.BAS
'          Add VC2(t) computation and plot
'          Put Q's on printed out version of 1st diagram
'          Add Tspark search option on 2nd diagram
'          Rename variables to comform to printed paper
'               K1 -> K3, K2 -> K4, A1 -> K1, A2 -> K2
'          VC2(t) and Tspark option incomplete
' TC17.BAS
'          Complete work on Tspark option
' TC18.BAS
'          Complete work on VC2(t) option
' TC19.BAS
'          Corrections as of 8/16/88
' TC20.BAS
'          Fix freq plot
' TC21.BAS
'          New quadratic root finder
'          Work on residual problem
' TC22.BAS
'          Complete work on the new root finder
' TC23.BAS
'          Revised root finders real case fixed via telephone
' TC24.BAS
'          Add Zoom mode on Vind(t) display
' TC25.BAS
'          Changes from Dr. Corum merged in 9/3/88
' TCI25.BAS
'          Internal version - Cohernce time calculation added
' TCI26.BAS
'          Add Zoom mode on VC2(t)
' TCI27.BAS
'          Add internal% flag for disabling undocumented features
'          Add speed diagram for master oscillator
' TCI28.BAS
'          Add speed diagram for resonator section
' TCI29.BAS
'          Final cleanup before publication
' TCI30.BAS
'          Allow resonator Speed Diagram to change Tspark or Vbase
'          independent of path through resonator section
' TCI31.BAS
'          Cleanup VCZoom  (3/24/89)
'
DECLARE FUNCTION ATN2! (num!, denom!)
DECLARE SUB ROOTS (A5!, B5!, C5!, D5!)
DECLARE SUB Menu24 (Menu0A$, S$)
DECLARE SUB Signon (V$)
COMMON ALPH15, W15, ALPH25, W25, bl$, CHRC$, CHBS$
CONST internal% = 0
'
CLS : NPNTS% = 70: NVALS% = 19: F = 5: FILEN$ = "": OFN$ = "TCVALUE.VAL"
Version$ = "Tesla Coil Tutor Program - TCTUTOR - Version 1.0 (2/20/89)"
PI = 3.14159265#: PPI = PI + PI
DIM VI(NPNTS%), R(NPNTS%), VC2(NPNTS%), E2(70), E2T(70): CV14$ = "V"
DIM rvs$(NVALS%), RVT(NVALS%), rvu$(NVALS%), rvl(NVALS%), rvh(NVALS%)
DIM cs$(NVALS%), CVR%(NVALS%), CVC%(NVALS%), PS$(NVALS%), cv(NVALS%)
CHCR$ = CHR$(13): CHBS$ = CHR$(8) ' Character Constants
DIAG% = 9 ' Top row of diagram
TsparkOpt$ = "N" ' Default no Tspark option
MenuV1S$ = "B" ' Set Vind(t) display at 28 usec
MenuC1S$ = "B" ' Same for VC2(t) display
MenuF1S$ = "A" ' Set freq range to 0 - 350 Khz
ZF$ = "5" ' Set default freq zoom start at 5KHz
ZFS$ = "F" ' Set defaulat freq zoom step at 5KHz
ZT$ = "5" ' Default voltage zoom start - 5 usec
ZTS$ = "A" ' Default voltaghe zoom step - .1 usec
ecs$ = "1" ' Set classical resonator
Banner$ = "----[ Recap of Component Values ]----"
EOFBanner$ = "----[ EOF ]----"
CALL Signon(Version$) ' Print signon scren
GOSUB initial ' Print initialize arrays
GOTO master1
master:
CALL Signon(Version$)
master1:
'
' check for reloaded parameters
'
IF internal% THEN
	SpeedyVal$ = ""
	SpeedyDiagram% = 0
	S$ = ""
AskAgain2:
	LOCATE 20, 1: PRINT bl$: PRINT bl$: PRINT bl$: LOCATE 20, 1
	INPUT "Load Values / Speed Diagram / Normal (L/S/N) [N]"; S$
	S$ = UCASE$(LEFT$(S$, 1))
	SELECT CASE S$
		CASE "N", ""
			GOTO part1
		CASE "L"
			GOSUB ReadVals
			IF ReadOk = 1 THEN
				CVAL% = 1
				SpeedyDiagram% = 1
			END IF
		CASE "S"
			SpeedyDiagram% = 1
		CASE ELSE
			GOTO AskAgain2
	END SELECT
ELSE
	S$ = ""
AskAgain:
	LOCATE 20, 1: PRINT bl$: PRINT bl$: PRINT bl$: LOCATE 20, 1
	INPUT "Load a previously saved data file (Y/N) [N]"; S$
	S$ = UCASE$(LEFT$(S$, 1))
	SELECT CASE S$
		CASE "N", ""
			GOTO part1
		CASE "Q", "X"
			SYSTEM
		CASE "Y"
			GOSUB ReadVals
			IF ReadOk = 1 THEN CVAL% = 1
		CASE ELSE
			GOTO AskAgain
	END SELECT
END IF
part1:
CLS : PRINT "                         TESLA COIL ANALYSIS"
PRINT
IF internal% THEN
LOCATE DIAG%, 1
PRINT "                         ": ' Top row of diagram here
ELSE
PRINT "   This program calculates the performance of classical Tesla Coils";
PRINT " as well as"
PRINT "the Colorado Springs machine."
PRINT "                         THE MASTER  OSCILLATOR"
PRINT "The program is based upon the analysis presented in THE TESLA HANDBOOK";
PRINT " by"
PRINT "Dr. J.F.Corum and K.L. Corum.  Consider the lumped coupled coils below."
PRINT "Note that C2 is greater during operation than under static conditions,";
PRINT " due to"
PRINT "corona.                  ": ' Top row of diagram here
END IF
PRINT "            Ĵ /\/\/\/\Ŀ   M";
PRINT "  /\/\/\/\Ŀ"
PRINT "                               R1             ";
PRINT "           R2         "
PRINT "  Ŀ               C1                     .  ";
PRINT ".                     "
PRINT "      )  (    (_)                            )   ";
PRINT " (                     /"
PRINT "      )  (                                   )   ";
PRINT " (                   /"
PRINT "      )  (     _                       L1    )   ";
PRINT " ( L2            C2  /"
PRINT "      )  (    (_)                            )   ";
PRINT " (                   / "
PRINT "                       I1                  ";
PRINT "          I2          "
PRINT "                           <                 ";
PRINT "         <         "
PRINT "                ";
PRINT "  "
PRINT
Part1A:
' Enter primary capacitance, C1 in microfarads
n = 1: GOSUB GetVal: C1 = cv
C1 = C1 / 1000000!
' Enter primary inductance, L1 in microhenries
n = 2: GOSUB GetVal: L1 = cv
L1 = L1 / 1000000!
' Enter primary resistance, R1 in ohms
n = 3: GOSUB GetVal: R1 = cv
QP = SQR(L1 / C1) / R1
LOCATE DIAG% + 5, 32: PRINT USING "###.# QPri"; QP
FP = .0001592 / SQR(L1 * C1)
LOCATE DIAG% + 6, 30: PRINT USING "#### KHz>"; FP;
LOCATE DIAG% + 5, 30: PRINT "";
LOCATE DIAG% + 4, 30: PRINT "";
LOCATE DIAG% + 3, 27: PRINT "<Ŀ";
GetNewM:
' Enter mutual inductance, M in microhenries
n = 4: GOSUB GetVal: M = cv
M = M / 1000000#
' Enter secondary inductance, L2 in milliheneries
n = 5: GOSUB GetVal: L2 = cv
L2 = L2 / 1000
L1L2 = L1 * L2
SQRL1L2 = SQR(L1L2)
K = M / SQRL1L2
IF K < .99 THEN GOTO KOk
LOCATE 22, 1
PRINT USING "Coupling not physically realizable:   k = #.###"; K
INPUT "Press ENTER and repeat."; S$
GOTO GetNewM
KOk:
' Enter secondary Capacitance, C2 in picofarads
n = 6: GOSUB GetVal: C2 = cv
C2 = C2 / 1E+12
LOCATE DIAG% + 6, 57
L2C2 = L2 * C2
SQRL2C2 = SQR(L2C2)
FO2 = .0001592 / SQRL2C2
PRINT USING "<-#### Khz->"; FO2;
IF (internal% AND SpeedyDiagram%) <> 1 THEN
ChngC2Q:
	LOCATE 20, 1
	PRINT bl$
	PRINT bl$
	PRINT bl$
	PRINT bl$
	LOCATE 20, 1
	S$ = ""
	INPUT "Do you want to change C2 (Y/N) [N]"; S$
	
	IF S$ = "" THEN S$ = "N"
	S$ = UCASE$(LEFT$(S$, 1))
	SELECT CASE S$
		CASE "Y"
			GOTO KOk
		CASE "N", ""
			GOTO Cont1A
		CASE ELSE
			GOTO ChngC2Q
	END SELECT
Cont1A:
END IF
' Enter secondary loss resistance, R2 in ohms
n = 7: GOSUB GetVal: R2 = cv
C1C2 = C1 * C2
R1R2 = R1 * R2
'
' Equation 24 - Critical Coupling
'
KC = SQR(R1R2 / SQR(L1L2 / C1C2))
' Enter peak voltage of the primary capacitor, V0 in KVolts
n = 8: GOSUB GetVal: VO = cv
LOCATE DIAG%, 23: PRINT "-> <-";
LOCATE 20, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$: LOCATE 20, 1
PRINT "The analysis will be based on the circuit values given above."
PRINT
n = 16: GOSUB GetVal: BPS = cv
' Equation xx
PAVG = BPS * C1 * VO * VO / .002
' Autorange between W and KW
IF PAVG < 1 THEN
	PPAVG = PAVG * 1000
	PAU$ = "W "
ELSE
	PPAVG = PAVG
	PAU$ = "KW"
END IF
LOCATE DIAG% + 5, 1: PRINT USING "####"; PPAVG;
LOCATE DIAG% + 6, 3: PRINT PAU$;
'
' SpeedyDiagram - change values here
'
IF internal% AND SpeedyDiagram% = 1 THEN
	LOCATE DIAG% - 3, 45: PRINT USING "k  = .####"; K;
	LOCATE DIAG% - 2, 45: PRINT USING "kc = .####"; KC;
Menu0A$ = "Change Component Value? (R1/L1/C1/M/R2/L2/C2/V0/BPS/N) [N]? "
Menu0A:
	CALL Menu24(Menu0A$, S$)
	S$ = UCASE$(S$)
	IF S$ = "N" OR S$ = "" THEN GOTO Cont1B
	SpeedyVal$ = ""
	FOR i% = 1 TO 8
		IF S$ = rvs$(i%) THEN
			SpeedyVal$ = S$
			EXIT FOR
		END IF
	NEXT i%
	IF rvs$(16) = S$ THEN SpeedyVal$ = S$
	IF SpeedyVal$ <> "" THEN GOTO Part1A
	GOTO Menu0A
'
ELSE
	LOCATE 20, 1
	PRINT "The power delivered to the oscillator";
	PRINT USING " (at N =##### BPS) is #### \\."; BPS; PPAVG; PAU$
	PRINT "This is the desired KVA rating for the power transformer."
	PRINT "(This assumes resonant charging, so that the spark gap arc";
	PRINT " is not a factor.)"
	PRINT "Press any key to continue ..."
WaitForKey1:
	IF INKEY$ = "" THEN GOTO WaitForKey1
END IF
Cont1B:
CLS : VI2MAX = 0: E2MAX = 0: VC2MAX = 0
PRINT "   During the energy interplay, the Secondary looks like:"
PRINT "               /\/\/\/\Ŀ"
PRINT "                         R2          "
PRINT USING "              (         #### ohms     "; R2
PRINT "              (   L2                  "
PRINT USING "              (  #### mh      C2   "; L2 * 1000
PRINT USING "                          #### pf "; C2 * 1E+12
PRINT "      +        .                      "
PRINT "             .   .                    "
PRINT "     Vind   .     .                   "
PRINT "             . ~ .        I2          "
PRINT "      -        .         <         "
PRINT "                                     "
PRINT "               "
' Denominator for the following expressions
DE = (L1L2 - M * M)
' Equation 10
A = (R1 * L2 + R2 * L1) / DE
' Equation 11
B = (L1 / C2 + L2 / C1 + R1R2) / DE
' Equation 12
C = (R1 / C2 + R2 / C1) / DE
' Equation 13
D = 1 / (C1C2 * DE)
'
' Already computed above
' k = M / SQR(L1 * L2)
'
LOCATE 3, 45: PRINT USING "Coefficient of coupling  k =.####"; K;
'
' Already computed above
' Equation 24
' kc = SQR(R1 * R2 / SQR(L1 * L2 / (C1 * C2)))
'
LOCATE 4, 45: PRINT USING "                       (kc =.####)"; KC;
'
' This section with solution of the 4th order equation number 9.
' The solution is especially tricky in the region near critical coupling.
'
' See Appendix 1 for more details.
'
' roots S = 100,000 * x'
'
A5 = A * .00001
B5 = B * 1E-10
C5 = C * 1E-15
D5 = D * 1E-20
CALL ROOTS(A5, B5, C5, D5)
IF W15 = 0 OR W25 = 0 THEN GOTO TooTight
W1 = W15 * 100000!
W2 = W25 * 100000!
W1R = W1 ' Save for use in Fourier Transform
W2R = W2
ALPH1 = -ALPH15 * 100000!
ALPH2 = -ALPH25 * 100000!
ALPH1R = ALPH1 ' Save for use in Fourier Transform
ALPH2R = ALPH2
ALPH15SQ = ALPH15 * ALPH15
ALPH25SQ = ALPH25 * ALPH25
W15SQ = W15 * W15
W25SQ = W25 * W25
P1234 = ALPH15SQ * ALPH25SQ + APLH15SQ * W25SQ
P1234 = P1234 + ALPH25SQ * W15SQ + W15SQ * W25SQ
DP = P1234 - D5
QROOT = 1
GOTO roots1
'
' Coupling too tight or no oscillation
'
TooTight:
LOCATE 6, 45: PRINT "--- Either the RF coupling is too"
LOCATE 7, 45: PRINT "tight, or losses are excessive,"
LOCATE 8, 45: PRINT "or Fop and Fos are too far apart."
OscDoubt:
LOCATE 14, 45: PRINT "** Oscillations are doubtful **";
ApproxSol:
LOCATE 19, 20: PRINT "* Solution is only approximate *"
QROOT = 0
roots1:
SQRBBM4D = SQR(B * B - 4 * D)
WR1 = SQR(.5 * (B + SQRBBM4D))
WR2 = SQR(.5 * (B - SQRBBM4D))
WR1SQ = WR1 * WR1
WR2SQ = WR2 * WR2
'
' W1 = HIGHER FREQUENCY  W2 = LOWER FREQUENCY
' Equations xx
'
ALPHR1 = (A * WR1SQ - C) / (2 * (WR1SQ - WR2SQ))
ALPHR2 = (A * WR2SQ - C) / (2 * (WR2SQ - WR1SQ))
IF QROOT = 0 THEN
	W1 = WR1
	W2 = WR2
	ALPH1 = ALPHR1
	ALPH2 = ALPHR2
END IF
ALPH1SQ = ALPH1 * ALPH1
ALPH2SQ = ALPH2 * ALPH2
W1SQ = W1 * W1
W2SQ = W2 * W2
F1 = W1 / PPI
F2 = W2 / PPI
A2MA1 = ALPH2 - ALPH1
A2MA1SQ = A2MA1 * A2MA1
WR1MWR2 = WR1 - WR2
W2PW1 = W2 + W1
W2PW1SQ = W2PW1 * W2PW1
ENUM = (-M * C1 * C2 * VO)
EDENOM = SQR((A2MA1SQ + WR1MWR2 * WR1MWR2) * (A2MA1SQ + W2PW1SQ))
E = ENUM / EDENOM
K3 = E * (ALPH1SQ + W1SQ) ^ 2 * (ALPH2SQ + W2SQ) / W1
K4 = E * (ALPH2SQ + W2SQ) ^ 2 * (ALPH1SQ + W1SQ) / W2
C2SQ = C2 * C2
L2C2 = L2 * C2
R2C2 = R2 * C2
R2M2A1L2 = (R2 - 2 * ALPH1 * L2)
R2M2A1L2SQ = R2M2A1L2 * R2M2A1L2
R2M2A2L2 = (R2 - 2 * ALPH2 * L2)
R2M2A2L2SQ = R2M2A2L2 * R2M2A2L2
K01 = (L2C2 * (ALPH1SQ - W1SQ) - R2C2 * ALPH1 + 1)
K1NUM = -K3 * SQR(K01 * K01 + W1SQ * C2SQ * R2M2A1L2SQ)
K1DENOM = M * C2 * (ALPH1SQ + W1SQ)
K1 = K1NUM / K1DENOM
K02 = (L2C2 * (ALPH2SQ - W2SQ) - R2C2 * ALPH2 + 1)
K2NUM = -K4 * SQR(K02 * K02 + W2SQ * C2SQ * R2M2A2L2SQ)
K2DENOM = M * C2 * (ALPH2SQ + W2SQ)
K2 = K2NUM / K2DENOM
T1 = ATN2((WR1 - WR2), (ALPH2 - ALPH1))
T2 = ATN2((W1 + W2), (ALPH2 - ALPH1))
' Equation 65
PHIL1NUM = W1 * C2 * R2M2A1L2
PHIL1DENOM = 1 - ALPH1 * R2C2 + L2C2 * (ALPH1SQ - WR1SQ)
PHIL1 = ATN2(PHIL1NUM, PHIL1DENOM)
PHI1 = PHIL1 - T1 - T2
PHIL2NUM = W2 * C2 * R2M2A2L2
PHIL2DENOM = 1 - ALPH2 * R2C2 + L2C2 * (ALPH2SQ - WR2SQ)
PHIL2 = ATN2(PHIL2NUM, PHIL2DENOM)
PHI2 = PHIL2 - T1 + T2
PHY1 = PHI1 * 57.29578
PHY2 = PHI2 * 57.29578
SINPHI1 = SIN(PHI1)
SINPHI2 = SIN(PHI2)
COSPHI1 = COS(PHI1)
COSPHI2 = COS(PHI2)
W1COS1MAL1SIN1 = W1 * COSPHI1 - ALPH1 * SINPHI1
W1SIN1PAL1COS1 = W1 * SINPHI1 + ALPH1 * COSPHI1
DW12 = W1 - W2
F1 = W1 / PPI
F2 = W2 / PPI
CVAL% = 1
PRINT
'
' Inital Tspark option
'
TsparkOptAsk:
LOCATE 23, 1
PRINT "Search a range for the spark duration,";
PRINT USING " Tspark that maximizes Vind (Y/N) [!]"; TsparkOpt$;
S$ = "": INPUT S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = TsparkOpt$
SELECT CASE S$
	CASE "N"
		TsparkOpt$ = S$
		GOTO PreMenu1
	CASE "Y"
		TsparkOpt$ = S$
	CASE ELSE
		GOTO TsparkOptAsk
END SELECT
'
' Coupute Tspark option
'
LOCATE 10, 45: PRINT "Start Tspark search at ";
n = 17: GOSUB GetVal: TsparkOptStart = cv
rvl(18) = cv
LOCATE 11, 45: PRINT "  End Tspark search at ";
n = 18: GOSUB GetVal: TsparkOptEnd = cv
IF TsparkOptEnd - TsparkOptStart < .01 THEN
	TsparkOptStep = 1
	GOTO TsparkOptComp
END IF
LOCATE 12, 45: PRINT " Step Tspark search by ";
n = 19: GOSUB GetVal: TsparkOptStep = cv
TsparkOptComp:
LOCATE 20, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$
TsparkOptMax = 0
TsparkOptVal = 0
TsparkOptTMax = 0
TsparkOptT = TsparkOptStart
LOCATE 5, 1: PRINT "   Tspark"
TsparkOptLoop:
T = TsparkOptT / 1000000
GOSUB CalcVind
IF ABS(Vind) > TsparkOptMax THEN
	TsparkOptMax = ABS(Vind)
	TsparkOptVal = Vind
	TsparkOptTMax = TsparkOptT
END IF
LOCATE 6, 1: PRINT USING "####.# usec"; TsparkOptT;
LOCATE 11, 1: PRINT USING "#####.## KV"; Vind;
TsparkOptT = TsparkOptT + TsparkOptStep
IF TsparkOptT < TsparkOptEnd THEN GOTO TsparkOptLoop
'
' Save Tspark for resonator calculation
'
cv(15) = TsparkOptTMax
LOCATE 4, 1: PRINT "   Optimum";
LOCATE 6, 1: PRINT USING "####.#"; TsparkOptTMax;
LOCATE 11, 1: PRINT USING "#####.## KV"; TsparkOptVal;
PreMenu1:
LOCATE 16, 1:
PRINT "We will now calculate Vinduced in both the Time and Frequency Domains."
PRINT "Note that the resonator peak voltage is a function of Vinduced,";
PRINT " not VC2."
PRINT "                       ( Vind = M d(i1)/dt )"
LOCATE 23, 1: PRINT bl$;
Menu1:
SpeedyDiagram% = 0
SpeedyVal$ = ""
LOCATE 24, 1
PRINT "Vind(t)/Vind(f)/Resonator/Master Osc/VC2(t)/Save Val/V(Ts)";
PRINT " (T/F/R/M/C/S/V)? ";
S$ = ""
Menu1Wait:
SS$ = INKEY$
SS$ = UCASE$(SS$)
SELECT CASE SS$
	CASE ""
		GOTO Menu1Wait
	CASE CHCR$
		GOTO Menu1Proc
	CASE IS < " "
		GOTO Menu1Restart
	CASE IS <> " "
		IF S$ = "" THEN
			S$ = SS$
			PRINT SS$;
		END IF
	CASE ELSE
END SELECT
GOTO Menu1Wait
'
Menu1Proc:
SELECT CASE S$
	CASE "V"
		GOTO VTScal
	CASE "T"
		GOTO Vind
	CASE "F"
		GOTO freq
	CASE "R"
		GOTO Resonator
	CASE "M"
		GOTO master
	CASE "C"
		GOTO VC2
	CASE "S"
		n% = 8
		GOSUB SaveVals
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		GOTO Menu1Restart
END SELECT
Menu1Restart:
LOCATE 24, 1: PRINT bl$; : GOTO Menu1
'
' Vind(t) and R(t)
'
Vind:
CLS
PRINT "    Secondary Induced Voltage, Vind(t) and Envelope,";
PRINT " R(t) Computation"
PRINT
PRINT "Select Time Range"
PRINT "   A  -  0 to 14 usec": PRINT "   B  -  0 to 28 usec"
PRINT "   C  -  0 to 70 usec": PRINT "   D  -  0 to 140 usec"
PRINT "   E  -  0 to 280 usec": PRINT "   F  -  0 to 700 usec"
PRINT "   Z  -  Zoom mode"
menuv1:
LOCATE 11, 1: INPUT "Enter your choice (A/B/C/D/E/F/Z)"; S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = MenuV1S$
SELECT CASE S$
	CASE "A"
		TS = .2
	CASE "B"
		TS = .4
	CASE "C"
		TS = 1
	CASE "D"
		TS = 2
	CASE "E"
		TS = 4
	CASE "F"
		TS = 10
	CASE "Z"
		MenuV1S$ = S$
		GOTO VoltZoom
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		LOCATE 8, 1
		PRINT bl$
		GOTO menuv1
END SELECT
MenuV1S$ = S$
TT = 0
TZ% = 0
ZC% = 0
CompVV:
LOCATE 13, 1
PRINT " T(usec)   R(t) (KV)   Vind (KV) for voltage peaks"
PRINT " -------   ---------   ---------"
'
' Time, TT in microseconds
'
VIMAX = 0: RTMAX = 0: VI2MAX = 0: TSVI = TS: LinePeak% = 15
VoltLast = 0: VoltLastMax = 0
FOR i% = 0 TO NPNTS%
	T = TT / 1000000!
	GOSUB CalcVind
	VABS = ABS(Vind)
	IF VABS < VoltLastMax AND LinePeak% < 23 THEN
		LinePeak% = LinePeak% + 1
		VoltLastMax = 0
	END IF
	LOCATE LinePeak%, 1
	PRINT USING " ###.#    ######      ######"; TT; RT; Vind
	IF VABS > VoltLastMax AND VABS > VoltLast THEN
		VoltLastMax = VABS
	END IF
	VoltLast = VABS
	VI(i%) = Vind: R(i%) = RT
	IF VABS > VIMAX THEN
		VIMAX = VABS
		VIT = TT
	END IF
	IF RT > RTMAX THEN
		RTMAX = RT
		RTT = TT
	END IF
	IF Vind < 0 THEN ZC% = 1
	IF ZC% > 0 AND VABS > VI2MAX THEN
		VI2MAX = VABS
		VI2T = TT
	END IF
	TT = TT + TS
NEXT i%
PlotSwitch = 1
GOSUB PlotV
GOTO Menu1
'
VoltZoom:
GOSUB GetVoltZoom
TT = TZ%
ZC% = 1
LOCATE 13, 1: FOR i% = 1 TO 7: PRINT bl$: NEXT i%
GOTO CompVV
'
' GetVoltZoom - Get Vind(t) Plot Zoom mode parameters
' Returns with TZ = T (starting time), TS (time step)
'
GetVoltZoom:
S$ = ""
LOCATE 14, 1
INPUT "Enter starting time, T in usec"; S$
IF S$ = "" THEN S$ = ZT$
T = VAL(S$)
IF T >= 0 AND T <= 1000 THEN
	GOTO GetVoltZoomTimeStep
END IF
PRINT "T"; T;
PRINT " not valid. T must be in the range 0 usec to 1000 usec. Re-enter F."
GOTO GetVoltZoom
GetVoltZoomTimeStep:
ZT$ = S$
LOCATE 15, 1: PRINT bl$
LOCATE 15, 1: PRINT "Select Time step, TS in usec"
PRINT "  A - 0.1 usec   B - 0.2 usec  C - 0.5 usec"
PRINT "  D -  1  usec   E -  2  usec  F -  5  usec"
PRINT "  G -  10 usec   H -  20 usec  I -  50 usec"
S$ = ZTS$
GetVZoomTSAgn:
LOCATE 19, 1: PRINT bl$
LOCATE 19, 1: INPUT "Enter selction letter (A/B/C/D/E/F/G/H/I)"; S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = ZTS$
SELECT CASE S$
	CASE "A"
		TS = .1
	CASE "B"
		TS = .2
	CASE "C"
		TS = .5
	CASE "D"
		TS = 1
	CASE "E"
		TS = 2
	CASE "F"
		TS = 5
	CASE "G"
		TS = 10
	CASE "H"
		TS = 20
	CASE "I"
		TS = 50
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		GOTO GetVZoomTSAgn
END SELECT
ZTS$ = S$
TZ% = T
RETURN
VC2:
'
' VC2(t)
'
CLS : PRINT "    Voltage across C2 during the spark time"
PRINT
PRINT "Select Time Range"
PRINT "   A  -  0 to 14 usec": PRINT "   B  -  0 to 28 usec"
PRINT "   C  -  0 to 70 usec": PRINT "   D  -  0 to 140 usec"
PRINT "   E  -  0 to 280 usec": PRINT "   F  -  0 to 700 usec"
PRINT "   Z  -  Zoom Mode"
MenuC1:
LOCATE 11, 1: INPUT "Enter your choice (A/B/C/D/E/F/Z)"; S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = MenuC1S$
SELECT CASE S$
	CASE "A"
		TS = .2
	CASE "B"
		TS = .4
	CASE "C"
		TS = 1
	CASE "D"
		TS = 2
	CASE "E"
		TS = 4
	CASE "F"
		TS = 10
	CASE "Z"
		MenuC1S$ = S$
		GOTO VCZoom
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		LOCATE 8, 1
		PRINT bl$
		GOTO MenuC1
END SELECT
MenuC1S$ = S$
TT = 0
TZ% = 0
CompVC2:
LOCATE 13, 1
PRINT " T(usec)   VC2(t) (KV) for voltage peaks"
PRINT " -------   -----------"
'
' Time, TT in microseconds
'
VC2MAX = 0: TSVC = TS
'
' constants
'
FC21 = -K3 / (C2 * SQR(ALPH1 * ALPH1 + W1 * W1))
FC22 = -K4 / (C2 * SQR(ALPH2 * ALPH2 + W2 * W2))
PSIC21 = -2 * ATN2(W1, ALPH1) - T1 - T2
PSIC22 = -2 * ATN2(W2, ALPH2) - T1 + T2
GAMC21 = PSIC21 + ATN2(-ALPH1, W1)
GAMC22 = PSIC22 + ATN2(-ALPH2, W2)
VoltLastMax = 0
VoltLast = 0
LinePeak% = 15
FOR i% = 0 TO NPNTS%
	T = TT / 1000000!
'
' Equation 26
'
	VC2 = FC21 * EXP(-ALPH1 * T) * COS(W1 * T + GAMC21)
	VC2 = VC2 + FC22 * EXP(-ALPH2 * T) * COS(W2 * T + GAMC22)
	VABS = ABS(VC2)
	IF VABS < VoltLastMax AND LinePeak% < 23 THEN
		LinePeak% = LinePeak% + 1
		VoltLastMax = 0
	END IF
	LOCATE LinePeak%, 1
	PRINT USING " ###.#      ######"; TT; VC2
	IF VABS > VoltLastMax AND VABS > VoltLast THEN
		VoltLastMax = VABS
	END IF
	VoltLast = VABS
	VC2(i%) = VC2
	IF VABS > VC2MAX THEN
		VC2MAX = VABS
		VC2T = TT
	END IF
	TT = TT + TS
NEXT i%
PlotSwitch = 2
GOSUB PlotV
GOTO Menu1
'
VCZoom:
GOSUB GetVoltZoom
TT = TZ%
LOCATE 13, 1: FOR i% = 1 TO 7: PRINT bl$: NEXT i%
GOTO CompVC2
'
freq:
'
' part 2   Fourier Spectrum
'
CLS : PRINT "             THE FOURIER SPECTRUM OF Vinduced"
PRINT : PRINT
PRINT USING "                   LF Peak: f2 = ####.# KHz"; F2 / 1000
PRINT USING "                   HF Peak: f1 = ####.# KHz"; F1 / 1000
PRINT : PRINT
PRINT "Select Frequency Range"
PRINT "   A  -  0 to 350 KHz"
PRINT "   B  -  0 to 1000 KHz"
PRINT "   C  -  0 to 2000 KHz"
PRINT "   Z  - Zoom mode"
menuf1:
LOCATE 13, 1: INPUT "Enter your choice (A/B/C/Z)"; S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = MenuF1S$
SELECT CASE S$
	CASE "A"
		F = 5
	CASE "B"
		F = 15
	CASE "C"
		F = 30
	CASE "Z"
		GOSUB GetZoom
		GOTO FreqComp1
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		LOCATE 13, 1
		PRINT bl$
		GOTO menuf1
END SELECT
FS = F
FZ = 0
FreqComp1:
MenuF1S$ = S$
'
' Use the real ALPH1,2 and W1,2 not the approximations ALPHR1,2 and WR1,2
'
PRINT "F(KHz)   Magnitude uV/SQR(Hz)"
'
' Pull constants outside the loop
'
P5C1 = -ALPH1R * K1 * COSPHI1
P5C2 = W1R * K1 * (ALPH1R * COSPHI1 - W1R * SINPHI1)
P6C1 = -ALPH2R * K2 * COSPHI2
P6C2 = W2R * K2 * (ALPH2R * COSPHI2 - W2R * SINPHI2)
P7C1 = ALPH1R * K1 * (ALPH1R * COSPHI1 - W1R * SINPHI1)
P7C2 = W1R * K1 * COSPHI1
P8C1 = ALPH2R * K2 * (ALPH2R * COSPHI2 - W2R * SINPHI2)
P8C2 = W2R * K2 * COSPHI2
G1C = ALPH1R * ALPH1R + W1R * W1R
G2C = ALPH2R * ALPH2R + W2R * W2R
ALPH1RT2 = 2 * ALPH1R
ALPH2RT2 = 2 * ALPH2R
PPIK = 1000 * PPI
FreqPrintLine% = 15: FreqPrintLastSign% = -1: E2Last = 1E+25
'
' Main Loop
'
FOR i% = 0 TO 70
	GOSUB CompVF
'
' Magnitude of V(f) for f in KHz
'
	E2Sign% = SGN(E2 - E2Last)
	IF E2Sign% <> E2LastSign% THEN
		E2LastSign% = E2Sign%
		FreqPrintLine% = FreqPrintLine% + 1
	END IF
	LOCATE FreqPrintLine%, 1
	PRINT USING "####.#    #######"; F; E2
	E2Last = E2
	E2(i%) = E2: E2T(i%) = F
	F = F + FS
NEXT i%
GOSUB PlotF
GOTO Menu1
'
' Actual V(f) computation
'
CompVF:
W = F * PPIK
WSQ = W * W
G1 = G1C - WSQ
G2 = G2C - WSQ
H1 = ALPH1RT2 * W
H2 = ALPH2RT2 * W
G11 = G1 * G1 + H1 * H1
G22 = G2 * G2 + H2 * H2
P1 = G1 / G11
P2 = G2 / G22
P3 = H1 / G11
P4 = H2 / G22
P5 = P5C1 * W + P5C2
P6 = P6C1 * W + P6C2
P7 = P7C1 + P7C2 * W
P8 = P8C1 + P8C2 * W
P9 = P1 * P5 + P2 * P6 + P3 * P7 + P4 * P8
P10 = P1 * P7 + P2 * P8 - P3 * P5 - P4 * P6
E2 = M * SQR(P9 * P9 + P10 * P10) * 1000000!
RETURN
'
' GetZoom - Get Frequency Plot Zoom mode parameters
' Returns with FZ = F (starting frequency), FS (freq step)
'
GetZoom:
S$ = ""
LOCATE 14, 1
INPUT "Enter starting frequency, F in KHz (must be a multiple of 5KHz)"; S$
IF S$ = "" THEN S$ = ZF$
F = VAL(S$): IF F >= 5 AND F <= 3000 THEN GOTO GetZoomFreqStep
PRINT "F"; F;
PRINT " not valid. F must be in the range 5 KHz to 3000 KHz. Re-enter F."
GOTO GetZoom
GetZoomFreqStep:
ZF$ = S$
F% = F / 5: F = F% * 5
LOCATE 15, 1: PRINT bl$
LOCATE 15, 1: PRINT "Select Frequency step, FS in KHz"
PRINT "  A - 0.1 KHz    B - 0.2 KHz   C - 0.5 KHz"
PRINT "  D -  1  KHz    E -  2  KHz   F -  5  KHz"
PRINT "  G -  10 KHz    H -  20 KHz   I -  50 KHz"
S$ = ZFS$
GetZoomFreqStepAgn:
LOCATE 19, 1: PRINT bl$
LOCATE 19, 1: INPUT "Enter selction letter (A/B/C/D/E/F/G/H/I)"; S$
S$ = UCASE$(LEFT$(S$, 1))
IF S$ = "" THEN S$ = ZFS$
SELECT CASE S$
	CASE "A"
		FS = .1
	CASE "B"
		FS = .2
	CASE "C"
		FS = .5
	CASE "D"
		FS = 1
	CASE "E"
		FS = 2
	CASE "F"
		FS = 5
	CASE "G"
		FS = 10
	CASE "H"
		FS = 20
	CASE "I"
		FS = 50
	CASE "Q", "X"
		SYSTEM
	CASE ELSE
		GOTO GetZoomFreqStepAgn
END SELECT
ZFS$ = S$
FZ = F
F = F + FS
RETURN
'
' Resonator / Extra Coil section
'
Resonator:
SpeedyDiagram% = 0
ResonMenuSaveChoice$ = "R"
ResonLoopCnt = 0
ResonatorRestart:
CLS
PRINT "   R E S O N A T O R  -  -  E X T R A   C O I L"
PRINT
PRINT "Coil Diameter, D                   Turn-to-turn spacing, s"
PRINT "Number of turns, n                 Wire Diameter, dw"
PRINT "Resonant Frequency, Estimated                Measured"
PRINT "Induced Voltage, Vind"
PRINT
IF internal% AND NOT SpeedyDiagram% THEN
	LOCATE 24, 1
	S$ = "N"
	Menu0A$ = "Speed Diagram (Y/N) [N]? "
	CALL Menu24(Menu0A$, S$)
	S$ = UCASE$(LEFT$(S$, 1))
	IF S$ = "Y" THEN
		SpeedyDiagram% = 1
		SpeedyVal$ = ""
	END IF
END IF
GetTurns:
' Coil Diameter (in feet)  D
n = 9: GOSUB GetVal: FD = cv
' Turn-to-turn spacing (in inches)  s
n = 10: GOSUB GetVal: S = cv
' Number of Turns on the coil n
n = 11: GOSUB GetVal: n = cv
H = n * S
IF n > 8.16 * FD / S THEN
	GOTO ZoOk
END IF
LOCATE 15, 1
PRINT "This value of n is too small.  The coil's H/D ratio is too small !"
LOCATE 17, 1
PRINT "Schelkunoff's formula for Zo doesn't work for short fat Coils."
GOTO GetTurns
ZoOk:
LOCATE 15, 1: PRINT bl$
LOCATE 17, 1: PRINT bl$
' Wire diameter (in inches) dw
n = 12: GOSUB GetVal: dw = cv
F = 1 / (PPI * SQR(L2C2))
' The secondary L2C2 operating frequency
LOCATE 5, 31: PRINT USING "###.# KHz"; F / 1000
n = 13: GOSUB GetVal: F = cv
F = F * 1000
' Equation xx
VF = 1 / SQR(1 + (FD / S) ^ 2.5 * 9970! * SQR((FD * F) / 9.843001E+08))
' Equation xx
Zo = 60 * (LOG(H / (3 * FD)) - 1) / VF
W = PPI * F
THETA = 3.0479E-08 * F * H / (VF)
THETR = THETA * .01745
ATTN = 7.8125 * (H / (12 * FD)) ^ .2 / (dw * Zo * SQR(F / 1000000!))
RBASE = Zo * ((1 - EXP(-2 * ATTN)) / (1 + EXP(-2 * ATTN)))
XC = -Zo * TAN(THETR)
CT = -1 / (W * XC)
DEN = Zo * Zo + XC * XC
AAA = (XC * XC - Zo * Zo) / DEN
BBB = (-2 * XC * Zo) / DEN
GAM = SQR(AAA * AAA + BBB * BBB)
PHIG = 2 * THETR - PI
LOCATE 21, 1: PRINT bl$: PRINT bl$: PRINT bl$
ClassExtra:
LOCATE 20, 1: PRINT bl$
LOCATE 20, 1
IF internal% AND SpeedyDiagram% THEN
	S$ = ecs$
	GOTO ChooseClassExtra
END IF
INPUT "Classical Tesla Coil-Resonator (1) or Extra Coil (2)"; S$
LOCATE 8, 1
IF S$ = "" THEN
	S$ = ecs$
ELSE
	S$ = LEFT$(S$, 1)
END IF
ChooseClassExtra:
IF S$ = "1" THEN GOTO Classical
IF S$ <> "2" GOTO ClassExtra
'
' Extra Coil computation
'
ec = 2: ec$ = "Extra Coil": ecs$ = "2"
GOSUB GetVTM
CompVBase:
Vbase = cv * RBASE / (RBASE + R2)
VOL = Vbase
GOTO results
Classical:
ec = 1: ec$ = "Classical Resonator": ecs$ = "1"
GOSUB GetVTM: Vbase = cv
VOL = Vbase
'
' Vbase (KV) VOL
'
results:
PRINT
PRINT USING "Secondary Resistance, R2 #### ohms"; R2
PRINT "                                                ";
PRINT USING "Vbase  ####.##"; Vbase
Vbase = 1000 * VOL
UP = SQR((1 + GAM * COS(PHIG)) ^ 2 + (GAM * SIN(PHIG)) ^ 2)
DWNP1 = (EXP(ATTN) * COS(THETR) + GAM * EXP(-ATTN) * COS(PHIG - THETR)) ^ 2
DWNP2 = (EXP(ATTN) * SIN(THETR) + EXP(-ATTN) * GAM * SIN(PHIG - THETR)) ^ 2
DWN = SQR(DWNP1 + DWNP2)
STP = UP / DWN
VTOP = Vbase * STP
LOCATE 20, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$
LOCATE 9, 1
PRINT USING "Base impedance, Rbase  #### ohms"; RBASE
PRINT USING "Top Capacitance, CT  ###.# pF"; CT * 1E+12
PRINT USING "Characteristic Impedance, Zo  ###### ohms"; Zo
PRINT USING "Electrical length of the resonator   ###.# degrees"; THETA
PRINT USING "Velocity factor, Vf  #.####"; VF
PRINT USING "Resonator Q = /2l  ####.#"; THETR / (2 * ATTN);
PRINT USING "     (/4 * S   ####.##)"; .7854 / ATTN
R3 = Zo * 1.621 * ATTN
PRINT USING "VSWR  ####.#                   "; 1 / ATTN;
ResonKC = .1592 * (1 / F) * SQR(R1 * R3 / L1L2)
PRINT USING "         kc #.####      k #.####"; ResonKC; K
PRINT USING "Voltage Step up  ####.#"; STP;
IF internal% THEN
	ResonCo = THETR * 1000000! / (25.1327 * ATTN * F)
	PRINT USING "             Coherence Time  = Q/2wo ###.# usec"; ResonCo
ELSE
	PRINT
END IF
PRINT "                        ";
PRINT USING "Vtop = ###.## MegaVolts   (&)"; VTOP / 1000000!; ec$
PRINT USING "Spark length (20 KV/in)  ####.# feet"; ABS(VTOP) / (20000! * 12!);
PRINT USING "           (8.7 KV/in  ####.# feet)"; ABS(VTOP) / (8700! * 12!)
IF internal% AND (ResonLoopCnt% MOD 10 <> 0) THEN
	PRINT
ELSE
PRINT
PRINT "This completes the analysis on a Tesla Coil. Analysis is great, HOWEVER"
PRINT "real insight comes from BUILDING Tesla Coils. This program can help you"
PRINT "refine the design, but significant accomplishment comes from BUILDING!"
PRINT
END IF
ResonLoopCnt% = ResonLoopCnt% + 1
ResonMenu:
LOCATE 24, 1: PRINT bl$; : LOCATE 24, 1
S$ = ""
IF internal% THEN
Menu$ = "Exit/Master Osc/Resonator/Save Val/Change Val/RePeat (X/M/R/S/C/P) ["
	Menu$ = Menu$ + ResonMenuSaveChoice$ + "]? "
	CALL Menu24(Menu$, S$)
ELSE
INPUT "Exit / Master Osc / Resonator / Save Values / RePeat (X/M/R/S/P) [R]"; S$
END IF
IF S$ = "" THEN S$ = ResonMenuSaveChoice$
S$ = UCASE$(LEFT$(S$, 1))
SELECT CASE S$
	CASE "X", "Q"
		SYSTEM
	CASE "M"
		GOTO master
	CASE "S"
		n% = 14
		GOSUB SaveVals
		GOTO ResonMenu
	CASE "P"
		GOTO Menu1
	CASE "C"
		IF internal% THEN
			GOSUB ResChngVal
			GOTO ResonatorRestart
		END IF
		GOTO ResonMenu
	CASE "R"
		GOTO Resonator
	CASE ELSE
		GOTO ResonMenu
END SELECT
'
' ResChngVal - Change single parameter value and recompute
'
ResChngVal:
IF internal% THEN
	ResonMenuSaveChoice$ = "C"
	LOCATE 24, 1: PRINT bl$;
	LOCATE 24, 1
	IF SpeedyVal$ <> "" THEN
		SS$ = SpeedyVal$
	ELSE
		SS$ = "0"
	END IF
	Menu0A$ = "Enter 1st 2 letters of item to change "
	Menu0A$ = Menu0A$ + "(D/s/n/dw/F/Vbase/Tspark/0) [" + SS$ + "]? "
	CALL Menu24(Menu0A$, S$)
	IF S$ = "" THEN S$ = SpeedyVal$
	S$ = UCASE$(LEFT$(S$, 2))
	SELECT CASE S$
		CASE "0", ""
			GOTO ResonMenu
		CASE "D", "F"
			SpeedyVal$ = S$
		CASE "S"
			SpeedyVal$ = "s"
		CASE "N"
			SpeedyVal$ = "n"
		CASE "DW"
			SpeedyVal$ = "dw"
		CASE "VB"
			SpeedyVal$ = "Vbase"
			CV14$ = "V"
		CASE "TS"
			SpeedyVal$ = "Tspark"
			CV14$ = "T"
		CASE ELSE
			SpeedyVal$ = ""
			GOTO ResChngVal
	END SELECT
SpeedyDiagram% = 1
END IF
RETURN
'
' Initialize arrays
'
initial:
rvs$(1) = "C1": RVT(1) = .127: rvu$(1) = "microfarads"
rvl(1) = .001: rvh(1) = .999: cs$(1) = ".### uF"
CVR%(1) = DIAG% + 4: CVC%(1) = 23
PS$(1) = "Enter the primary Capacitance, C1 in microfarads ... "
rvs$(2) = "L1": RVT(2) = 57: rvu$(2) = "microhenries"
rvl(2) = 1: rvh(2) = 999: cs$(2) = "### uH"
CVR%(2) = DIAG% + 7: CVC%(2) = 40
PS$(2) = "Enter the primary Inductance, L1 in microhenries ... "
rvs$(3) = "R1": RVT(3) = 8: rvu$(3) = "ohms"
rvl(3) = .1: rvh(3) = 100: cs$(3) = "###.# ohms"
CVR%(3) = DIAG% + 3: CVC%(3) = 32
PS$(3) = "Enter the primary Resistance, R1 in ohms ... "
rvs$(4) = "M": RVT(4) = 425: rvu$(4) = "microhenries"
rvl(4) = 1: rvh(4) = 4000: cs$(4) = "#### uH"
CVR%(4) = DIAG%: CVC%(4) = 47
PS$(4) = "Enter the Mutual Inductance, M in microhenries ... "
rvs$(5) = "L2": RVT(5) = 9: rvu$(5) = "millihenries"
rvl(5) = 1: rvh(5) = 4000: cs$(5) = "#### mH"
CVR%(5) = DIAG% + 7: CVC%(5) = 55
PS$(5) = "Enter the secondary Inductance, L2 in milliheneries ... "
rvs$(6) = "C2": RVT(6) = 300: rvu$(6) = "picofarads"
rvl(6) = 1: rvh(6) = 4000: cs$(6) = "#### pF"
CVR%(6) = DIAG% + 5: CVC%(6) = 65
PS$(6) = "Enter the secondary Capacitance, C2 in picofarads ... "
rvs$(7) = "R2": RVT(7) = 45: rvu$(7) = "ohms"
rvl(7) = 10: rvh(7) = 5000: cs$(7) = "#### ohms"
CVR%(7) = DIAG% + 3: CVC%(7) = 59
PS$(7) = "Enter the secondary loss resistance, R2 in ohms ... "
rvs$(8) = "V0": RVT(8) = 70: rvu$(8) = "KVolts"
rvl(8) = .1: rvh(8) = 500: cs$(8) = "###.# KV"
CVR%(8) = DIAG%: CVC%(8) = 15
PS$(8) = "Enter the peak voltage of the primary capacitor, V0 in KVolts ... "
rvs$(9) = "D": RVT(9) = 8: rvu$(9) = "feet"
rvl(9) = .1: rvh(9) = 500: cs$(9) = "###.# feet"
CVR%(9) = 3: CVC%(9) = 18
PS$(9) = "Enter the resonator coil diameter in feet ... "
rvs$(10) = "s": RVT(10) = 1: rvu$(10) = "inches"
rvl(10) = .001: rvh(10) = 9: cs$(10) = "#.### inches"
CVR%(10) = 3: CVC%(10) = 60
PS$(10) = "Enter the resonator coil turn-to-turn spacing, s in inches ... "
rvs$(11) = "n": RVT(11) = 110: rvu$(11) = "turns"
rvl(11) = 10: rvh(11) = 5000: cs$(11) = "#### turns"
CVR%(11) = 4: CVC%(11) = 20
PS$(11) = "Enter the resonator coil number of turns, n ... "
rvs$(12) = "dw": RVT(12) = .125: rvu$(12) = "inches"
rvl(12) = .001: rvh(12) = 9: cs$(12) = "#.### inches"
CVR%(12) = 4: CVC%(12) = 54
PS$(12) = "Enter the resonator coil wire diameter, dw in inches ... "
rvs$(13) = "F": RVT(13) = 94: rvu$(13) = "KHz"
rvl(13) = 10: rvh(13) = 9000: cs$(13) = "#### KHz"
CVR%(13) = 5: CVC%(13) = 55
PS$(13) = "Enter the measured resonator coil resonant frequency, F in KHz ... "
rvs$(14) = "Vbase": RVT(14) = 420: rvu$(14) = "KV"
rvl(14) = -5000: rvh(14) = 5000: cs$(14) = "####.## KV"
CVR%(14) = 6: CVC%(14) = 22
PS$(14) = "Enter the resonator coil base voltage, Vbase in KV ... "
rvs$(15) = "Tspark": RVT(15) = 10.5: rvu$(15) = "usec"
rvl(15) = .1: rvh(15) = 10000: cs$(15) = "#####.## usec"
CVR%(15) = 6: CVC%(15) = 60
PS$(15) = "Enter the master oscillator spark duration time, Tspark in usec ... "
rvs$(16) = "BPS": RVT(16) = 1: rvu$(16) = "breaks/sec"
rvl(16) = 1: rvh(16) = 99999: cs$(16) = "##### breaks/sec"
CVR%(16) = DIAG% + 6: CVC%(16) = 13
PS$(16) = "Enter the master oscillator spark breaks per sec, BPS ... "
rvs$(17) = "Tss": RVT(17) = 9: rvu$(17) = "usec"
rvl(17) = .1: rvh(17) = 9998: cs$(17) = "####.# usec"
CVR%(17) = 10: CVC%(17) = 68
PS$(17) = "Enter start of Tspark search range in usec ... "
rvs$(18) = "Tse": RVT(18) = 12: rvu$(18) = "usec"
rvl(18) = .1: rvh(18) = 9999: cs$(18) = "####.# usec"
CVR%(18) = 11: CVC%(18) = 68
PS$(18) = "Enter end of Tspark search range in usec ... "
rvs$(19) = "Tsst": RVT(19) = .1: rvu$(19) = "usec"
rvl(19) = .01: rvh(19) = 100: cs$(19) = "###.## usec"
CVR%(19) = 12: CVC%(19) = 68
PS$(19) = "Enter step interval of Tspark search range in usec ... "
FOR i% = 1 TO NVALS%: cv(i%) = RVT(i%): NEXT i%
bl$ = STRING$(79, 32)
CVAL% = 0
RETURN
'
' Subroutine GetVal - gets an input value for a specific parameter
' On call - N is parameter number
' On return - CV is the new current value for the parameter
'
GetVal:
IF internal% THEN
	IF SpeedyDiagram% = 1 AND SpeedyVal$ <> rvs$(n) THEN
		cv$ = ""
		GOTO GetSpeedyVal
	END IF
END IF
LOCATE 22, 1
PRINT bl$: PRINT bl$: PRINT bl$;
GetValAgain:
LOCATE 20, 1
PRINT bl$: PRINT bl$
LOCATE 21, 1
IF CVAL% = 0 THEN GOTO NoCV
PRINT "Present value is ";
PRINT USING cs$(n); cv(n)
NoCV:
LOCATE 20, 1
PRINT PS$(n);
cv = 0: cv$ = "": INPUT cv$: cv = VAL(cv$)
GetSpeedyVal:
IF cv$ = "" THEN cv = cv(n)
IF cv < rvl(n) OR cv > rvh(n) THEN
	GOTO GetValBad
END IF
cv(n) = cv
LOCATE CVR%(n), CVC%(n)
PRINT USING cs$(n); cv(n);
RETURN
'
' Value out of the reasonable range
'
GetValBad:
LOCATE 22, 1
PRINT "Reasonable values for parameter "; rvs$(n); " range from";
PRINT rvl(n); " to"; rvh(n); rvu$(n); "."
PRINT "The value for "; rvs$(n); " from Tesla's Diary (November 1899)";
PRINT " was "; RVT(n); rvu$(n); ""
PRINT "Re-enter your choice for "; rvs$(n); " in "; rvu$(n); " ... ";
GOTO GetValAgain
'
' PlotF - Frequency plot subroutine
'
PlotF:
E2MIN = 1E+21: E2MAX = 0: FOR i% = 1 TO 70
IF E2(i%) > E2MAX THEN E2MAX = E2(i%): E2TC = E2T(i%)
IF E2(i%) < E2MIN THEN E2MIN = E2(i%)
NEXT i%
IF E2MAX <= 0 THEN RETURN
YMIN = 0
IF ((E2MAX - E2MIN) / E2MAX) > .75 THEN GOTO CompVertScale
SMIN = 1
YMINX = 0
NextMinRange:
YMIN = YMINX * SMIN: YMINX = 1: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
YMIN = YMINX * SMIN: YMINX = 1.5: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
YMIN = YMINX * SMIN: YMINX = 2: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
YMIN = YMINX * SMIN: YMINX = 3: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
YMIN = YMINX * SMIN: YMINX = 5: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
YMIN = YMINX * SMIN: YMINX = 7.5: IF E2MIN < YMINX * SMIN THEN GOTO CompVertScale
SMIN = SMIN * 10: GOTO NextMinRange
CompVertScale:
'
SMAX = 1
NextRange:
YMAX = 2: IF E2MAX - YMIN < YMAX * SMAX THEN GOTO ContF
YMAX = 5: IF E2MAX - YMIN < YMAX * SMAX THEN GOTO ContF
YMAX = 10: IF E2MAX - YMIN < YMAX * SMAX THEN GOTO ContF
SMAX = SMAX * 10: GOTO NextRange
ContF:
CLS : Y0% = 20: YA% = 1: Y0B = YMIN: Y0S = SMAX: GOSUB DrawYAxis
XA$ = CHR$(192): XAU$ = STRING$(4, 196)
XAV$ = XAU$ + CHR$(193) + XAU$ + CHR$(197)
XA$ = XA$ + XAV$ + XAV$ + XAV$ + XAV$ + XAV$ + XAV$ + XAU$
XA$ = XA$ + CHR$(193) + XAU$ + CHR$(180)
F = F2 / 1000
LOCATE 3, 47: PRINT USING "LF Peak: f2 = ####.# KHz"; F;
GOSUB CompVF: EF2 = E2
LOCATE 4, 60: PRINT USING "(###### VHz)"; EF2;
F = F1 / 1000
LOCATE 5, 47: PRINT USING "HF Peak: f1 = ####.# KHz"; F;
GOSUB CompVF: EF1 = E2
LOCATE 6, 60: PRINT USING "(###### VHz)"; EF1;
LOCATE 7, 49: PRINT USING "k = .####  (kc = .####)"; K; KC
LOCATE 21, 7: PRINT XA$;
XAL = FZ
FOR i% = 0 TO 7
XAF$ = "####"
IF XAL < 999 THEN XAF$ = "###"
IF XAL < 99 THEN XAF$ = "##"
LOCATE 22, 6 + 10 * i%
PRINT USING XAF$; XAL; : XAL = XAL + 10 * FS
NEXT i%
LOCATE 22, 41: PRINT "KHz";
LOCATE 23, 1: PRINT "FOURIER SPECTRUM OF Vind";
PRINT USING "     Max plotted value = ###### VHz at ####.# KHz"; E2MAX; E2TC;
E2SF = 40 / (YMAX * SMAX)
FOR i% = 1 TO 70
J% = 20: E2P = (E2(i%) - YMIN) * E2SF: E2 = 1
FreqPlotLoop:
LOCATE J%, i% + 7
IF E2 < E2P THEN C$ = CHR$(220)
E2 = E2 + 1: IF E2 < E2P THEN C$ = CHR$(219)
PRINT C$; : J% = J% - 1
E2 = E2 + 1: IF E2 < E2P THEN GOTO FreqPlotLoop
NEXT i%
LOCATE 24, 1
RETURN
'
' PlotV - Plots either Vind(t) and R(t) or VC2(t)
'
PlotV:
' Plot Vind(t) and R(t)
IF PlotSwitch = 1 THEN VPMAX = VIMAX ELSE VPMAX = VC2MAX
CLS
SFMAX = RTMAX: IF VPMAX > SFMAX THEN SFMAX = VPMAX
SMAX = .1
PlotVNextRange:
YMAX = 2: IF SFMAX < YMAX * SMAX THEN GOTO PlotV1
YMAX = 5: IF SFMAX < YMAX * SMAX THEN GOTO PlotV1
YMAX = 10: IF SFMAX < YMAX * SMAX THEN GOTO PlotV1
SMAX = SMAX * 10: GOTO PlotVNextRange
PlotV1:
Y0% = 10: YA% = 2: Y0B = 0: Y0S = 1: GOSUB DrawYAxis: SFMAX = YMAX * SMAX
LOCATE 11, 6
XAU$ = STRING$(4, 196)
XAV$ = XAU$ + CHR$(193) + XAU$ + CHR$(197)
FOR i% = 1 TO 7: PRINT XAV$; : NEXT i%
GOSUB LabelXAxis
SF = 10 / SFMAX
IF PlotSwitch = 2 THEN GOTO PlotVC2
FOR i% = 1 TO NPNTS%
PNT% = R(i%) * SF
LOCATE 11 - PNT%, i% + 5: PRINT "-";
LOCATE 11 + PNT%, i% + 5: PRINT "-";
PNT% = VI(i%) * SF
LOCATE 11 - PNT%, i% + 5: PRINT "*";
NEXT i%
LOCATE 1, 28
PRINT USING "Useful Peak  Vind = #####.# KV at t = ####.# usec"; VI2MAX; VI2T
LOCATE 3, 53
PRINT USING " k = #.###  (kc = #.###)"; K; KC
LOCATE 21, 25
PRINT USING "R(t)    -  Max value is #####.# KV at t = #### usec"; RTMAX; RTT;
LOCATE 22, 25
PRINT USING "Vind(t) *  Max value is #####.# KV at t = #### usec"; VIMAX; VIT;
GOTO LabelXAxisAgn
PlotVC2:
FOR i% = 1 TO NPNTS%
PNT% = VC2(i%) * SF
LOCATE 11 - PNT%, i% + 5: PRINT "*";
NEXT i%
LOCATE 1, 30
PRINT USING "Peak  VC2 = #####.# KV at t = ####.# usec"; VC2MAX; VC2T
LOCATE 3, 53
PRINT USING " k = #.###  (kc = #.###)"; K; KC
LabelXAxisAgn:
GOSUB LabelXAxis: LOCATE 24, 1: RETURN
'
' Label Vind(t), R(t) X Axis
'
LabelXAxis:
ILX% = TZ%
FOR i% = 0 TO 7
	ILC% = 5 + 10 * i%
	SELECT CASE ILX%
		CASE IS < 10
			LOCATE 12, ILC%
			PRINT USING "#"; ILX%;
		CASE IS < 100
			LOCATE 12, ILC%
			PRINT USING "##"; ILX%;
		CASE IS < 1000
			LOCATE 12, ILC% - 1
			PRINT USING "###"; ILX%
		CASE ELSE
			LOCATE 12, ILC% - 1
			PRINT USING "####"; ILX%
	END SELECT
	ILX% = ILX% + 10 * TS
NEXT i%
RETURN
'
' Draw Y axis for voltage and frequency plots
' YA% = 1 for Freq plot, YA% = 2 for voltage plot
' YMAX sets vertical divisons
' Y0% = number of steps to zero line
' Y0B = label for base of Freq plot, 0 for voltage plot
' Y0S = Scale to multiple Y axis label
'
DrawYAxis:
IF YMAX = 10 THEN YDIV = 2 ELSE YDIV = 1
IF YA% = 2 THEN
     VA1$ = "### !": VA2$ = "    !"
ELSE
     VA1$ = "##### !": VA2$ = "      !"
END IF
FOR i% = 1 TO 21
    LOCATE i%, 1
    YWRK = (Y0% + 1 - i%) * YMAX / Y0%
    YVAL% = YWRK / YDIV
    YPLOT = YWRK * Y0S + Y0B
    IF YVAL% * YDIV = YWRK THEN
	 PRINT USING VA1$; YPLOT; CHR$(197);
    ELSE
	 PRINT USING VA2$; CHR$(179);
    END IF
NEXT i%: RETURN
'
' SAVE VALUES
'
SaveVals:
CLS : IF FILEN$ <> "" THEN OFN$ = FILEN$
FnameAgn:
FILEN$ = "": INPUT "Enter File Name for saved values"; FILEN$
IF FILEN$ = "" THEN FILEN$ = OFN$
FILEN$ = UCASE$(FILEN$)
IF INSTR(FILEN$, " ") > 0 THEN GOTO FnameBad
IF INSTR(FILEN$, "*") > 0 THEN GOTO FnameBad
IF INSTR(FILEN$, "?") = 0 THEN GOTO FnameOk
FnameBad:
PRINT "ERROR - Invalid character in File Name "; FILEN$: GOTO FnameAgn
FnameOk:
IF INSTR(FILEN$, ".") = 0 THEN FILEN$ = FILEN$ + ".VAL"
ErrFlag = 1: ON ERROR GOTO OpenFileNotFnd
OPEN FILEN$ FOR INPUT AS #1
ON ERROR GOTO 0
IF ErrFlag = 0 THEN GOTO OpenOutput
CLOSE #1
PRINT "File "; FILEN$; " exists. Overwrite it (Y/N) [N]";
S$ = "": INPUT S$: S$ = UCASE$(LEFT$(S$, 1))
IF S$ <> "Y" THEN GOTO FnameAgn
OpenOutput:
ON ERROR GOTO 0
OPEN FILEN$ FOR OUTPUT AS #1
PRINT "Writing Tesla Coil parameter values on file "; FILEN$
PRINT #1, "TESLA COIL component values computed on "; DATE$; " at "; TIME$
PRINT #1, " ": PRINT #1, "Master Oscillator Values"
PRINT #1, "------------------------"
REM Note: All Underscores (.) must be doubled in PRINT USING formats
PRINT #1, USING "                   ###.# KV     "; cv(8);
PRINT #1, USING "             #### uH"; cv(4)
PRINT #1, "           ___________| |_____/\/\/\/\";
PRINT #1, "______    M   ______/\/\/\/\_______"
PRINT #1, " ___      |    |      | |        R1   "
PRINT #1, "      | .  . |         R2          |"
PRINT #1, USING "    ) || (    (__)     C1        ###.# ohms"; cv(3);
PRINT #1, USING "   )    (        #### ohms     |/"; cv(7)
PRINT #1, USING "####) || (          .### uF   "; PPAVG; cv(1);
PRINT #1, USING "               )    (            #### pF --/--"; cv(6)
PRINT #1, USING " \\ ) || (##### breaks/sec    "; PAU$; cv(16);
PRINT #1, USING "         L1    )    ( L2 <-#### KHz->C2  -/---"; FO2
PRINT #1, USING " ______) || (    (__)           I1       ### uH"; cv(2);
PRINT #1, USING "  )    ( #### mH    I2      / |"; cv(5)
PRINT #1, "          |    |           <---      ";
PRINT #1, "       |      |          <---       |"
PRINT #1, "           ---------------------------------       ";
PRINT #1, " ----------------------"
PRINT #1, " "
PRINT #1, USING "P(avg) = #### \\."; PPAVG; PAU$
PRINT #1, " "
IF n% <= 8 THEN GOTO PrintK
PRINT #1, "Resonator / Extra Coil Values"
PRINT #1, "-----------------------------"
FOR i% = 9 TO n%
PRINT #1, rvs$(i%); "  ",
PRINT #1, USING cs$(i%); cv(i%)
NEXT i%: PRINT #1, rvs$(15),
IF cv(15) > 0 THEN
     PRINT #1, USING cs$(15); cv(15)
ELSE
     PRINT #1, "Not Given"
END IF
PRINT #1, USING "Base impedance, Rbase  #### ohms"; RBASE
PRINT #1, USING "Top Capacitance, CT  ###.# pF"; CT * 1E+12
PRINT #1, USING "Characteristic Impedance, Zo  ###### ohms"; Zo
PRINT #1, USING "Electrical length of the resonator   ###.# degrees"; THETA
PRINT #1, USING "Velocity factor, Vf  #.####"; VF
PRINT #1, USING "Resonator Q   ####.#"; THETR / (2 * ATTN);
PRINT #1, USING "     (Pi/4 * S   ###.##)"; .7854 / ATTN
R3 = Zo * 1.621 * ATTN
PRINT #1, USING "VSWR  ####.#                "; 1 / ATTN;
ResonKC = .1592 * (1 / F) * SQR(R1 * R3 / L1L2)
PRINT #1, USING "            kc #.####      k #.####"; ResonKC; K
PRINT #1, USING "Voltage Step up  ####.#             "; STP;
IF internal% THEN
	ResonCo = THETR * 1000000! / (25.1327 * ATTN * F)
	PRINT #1, USING "Coherence Time  = Q/2wo ###.# usec"; ResonCo
ELSE
	PRINT #1, " "
END IF
PRINT #1, "                        ";
PRINT #1, USING "Vtop = ###.## MegaVolts   (&)"; VTOP / 1000000!; ec$
PRINT #1, USING "Spark length (20 KV/in)  ####.# feet"; ABS(VTOP) / 240000!;
PRINT #1, USING "           (8.7 KV/in  ####.# feet)"; ABS(VTOP) / 104400!
GOTO PrintVT
PrintK:
PRINT #1, USING "k     .####       kc   .####"; K; KC;
PRINT #1, " "
PrintVT:
IF VI2MAX = 0 THEN
     PRINT "Vind(t) and R(t) were not computed and cannot be saved."
     GOTO SaveFreq
END IF
PRINT #1, " "
PRINT #1, "t (usec)     R(KV)      Vind (KV)"
PRINT #1, "--------     -----      ---------"
FOR i% = 0 TO NPNTS%
PRINT #1, USING " ###.#      #####.#     #####.###"; TSVI * i%; R(i%); VI(i%)
NEXT i%
SaveFreq:
IF E2MAX = 0 THEN
     PRINT "The Fourier Spectrum was not computed and cannot be saved."
     GOTO SaveVC2
END IF
PRINT #1, " "
PRINT #1, "F(KHz)    E2 [uv/sqr(Hz)]"
PRINT #1, "------    ---------------"
FOR i% = 0 TO 70
PRINT #1, USING " ####       ######"; i% * FS; E2(i%)
NEXT i%
SaveVC2:
IF VC2MAX = 0 THEN GOTO SaveDone
PRINT #1, " "
PRINT #1, "t (usec)     VC2 (KV)"
PRINT #1, "--------     ---------"
FOR i% = 0 TO NPNTS%
PRINT #1, USING " ###.#      #####.###"; TSVC * i%; VC2(i%)
NEXT i%
SaveDone:
PRINT #1, " "
PRINT #1, Banner$
PRINT #1, " "
FOR i% = 1 TO NVALS%
IF i% = 9 THEN PRINT #1, ec$: ' Save Classical or Extra Coil flag
PRINT #1, rvs$(i%), cv(i%); rvu$(i%)
NEXT i%
PRINT #1, " "
PRINT #1, EOFBanner$
CLOSE #1: RETURN
'
' GerVTM - Get or compute base voltage
'
GetVTM:
IF internal% AND SpeedyDiagram% THEN
	S$ = CV14$
	GOTO SelectVTM
END IF
LOCATE 18, 1
PRINT "We now need to know the voltage induced (Vind) in the secondary."
PRINT "This can be entered either as some value which you suggest, Vind in KV,";
PRINT " or as"
PRINT "the spark duration time, Tspark in usec (which permits us to calculate";
PRINT " Vind),"
PRINT "or as the Maximum usable value as determined from the oscilloscope";
PRINT " above."
GetVTMAgn:
LOCATE 23, 1: PRINT bl$;
LOCATE 23, 1: S$ = "": IF VI2MAX > 0 THEN GOTO GetVTMMenu2
INPUT "Enter V for voltage or T for time (V / T)"; S$
GOTO TestMenu2
GetVTMMenu2:
INPUT "Enter V for voltage, T for time or M for max available Vind (V/T/M)"; S$
TestMenu2:
IF S$ = "" THEN S$ = CV14$
S$ = UCASE$(LEFT$(S$, 1))
SelectVTM:
SELECT CASE S$
	CASE "V"
		GOTO GetVTMV
	CASE "T"
		GOTO GetVTMT
	CASE "M"
		IF VI2MAX > 0 THEN
			GOTO GetVTMM
		END IF
	CASE ELSE
END SELECT
GOTO GetVTMAgn
'
GetVTMV:
CV14$ = "V": LOCATE 19, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$
n = 14: GOSUB GetVal: cv(15) = 0
GOTO RetVTM
'
GetVTMT:
CV14$ = "T": LOCATE 19, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$
LOCATE 6, 36: PRINT "Spark Duration, Tspark";
n = 15: GOSUB GetVal: T = cv / 1000000!: GOSUB CalcVind: cv = ABS(Vind)
cv(14) = cv
LOCATE CVR%(14), CVC%(14)
PRINT USING cs$(14); cv(14);
GOTO RetVTM
'
GetVTMM:
CV14$ = "M": LOCATE 19, 1: PRINT bl$: PRINT bl$: PRINT bl$: PRINT bl$
LOCATE 6, 1
PRINT USING "Induced Voltage, Vind  ####.#        at ##.## usec"; VI2MAX; VI2T
cv = VI2MAX: cv(14) = cv: cv(15) = VI2T
RetVTM:
RETURN
'
' CalcVind - Subroutine to calcuate Vind(t) and R(t)
' Calls with T
' Returns with VIND and RT
' Uses serveral constants involving W1, ALPH1,2 and PHI1,2 which were
' computed at the end of part 1
'
CalcVind:
'
' Compute common subexpressions
'
W1T = W1 * T
DWT = DW12 * T
EXPMAL1T = EXP(-ALPH1 * T)
K1EXPMAL1T = K1 * EXPMAL1T
EXPMAL2T = EXP(-ALPH2 * T)
K2EXPMAL2T = K2 * EXPMAL2T
SINDWTMP2 = SIN(DWT - PHI2)
COSDWTMP2 = COS(DWT - PHI2)
'
' W1COS1MAL1SIN1 = W1 * COS(PHI1) - ALPH1 * SIN(PHI1)
' W1SIN1PAL1COS1 = W1 * SIN(PHI1) + ALPH1 * COS(PHI1)
'
VI1 = W2 * COSDWTMP2 + ALPH2 * SINDWTMP2
VI = M * (K1EXPMAL1T * W1COS1MAL1SIN1 + K2EXPMAL2T * VI1)
VQ1 = ALPH2 * COSDWTMP2 - W2 * SINDWTMP2
VQ = M * (K1EXPMAL1T * W1SIN1PAL1COS1 + K2EXPMAL2T * VQ1)
RT = SQR(VI * VI + VQ * VQ)
' PH = ATN(VQ / VI)
Vind = VI * COS(W1T) - VQ * SIN(W1T)
RETURN
'
' ReadVals - Read file previously saved to load new defaults.
'
' returns ReadOk = 1 if file read, else ReadOk = 0
'
ReadVals:
INPUT "Enter input file name"; S$
S$ = UCASE$(S$)
IF S$ = "Q" OR S$ = "X" THEN SYSTEM
IF INSTR(S$, ".") = 0 THEN S$ = S$ + ".VAL"
ErrFlag = 0: ON ERROR GOTO FileErr
OPEN S$ FOR INPUT AS #2
IF ErrFlag <> 0 THEN
	GOTO ReadVals
END IF
ON ERROR GOTO 0 ' Terminate error handling
RFN$ = S$ ' Save file name
'
' Look for marker that signals values to reload
'
Read1stLoop:
IF EOF(2) THEN
	GOTO FileEOF1
END IF
INPUT #2, S$
IF S$ <> Banner$ THEN
	GOTO Read1stLoop
END IF
i% = 0
'
' Found Banner - go on
'
Read2ndLoop:
IF EOF(2) THEN GOTO FileEOF2: ' Go if unexpected EOF
INPUT #2, sv$
SELECT CASE sv$
	CASE "", " "
		GOTO Read2ndLoop
	CASE EOFBanner$
		GOTO ReadDone
	CASE "Classical Resonator"
		ecs$ = "1"
		PRINT sv$
		GOTO Read2ndLoop
	CASE "Extra Coil"
		ecs$ = "2"
		PRINT sv$
		GOTO Read2ndLoop
	CASE ELSE
END SELECT
'
' found component entry - process it
'
J% = 1: jmax% = LEN(sv$)
Read3rdLoop:
'
' Look for 1st space
'
IF MID$(sv$, J%, 1) = " " THEN
	GOTO ReadFndName
END IF
IF J% = jmax% THEN
	GOTO FileBad
ELSE
	J% = J% + 1
	GOTO Read3rdLoop
END IF
ReadFndName:
'
' Split off entry name
'
SS$ = MID$(sv$, 1, J% - 1)
sv$ = RIGHT$(sv$, jmax% - J%)
'
' Look up in rvs$ table
'
XOk = 0
FOR J% = 1 TO NVALS%
	IF SS$ = rvs$(J%) THEN
		XOk = 1
		EXIT FOR
	END IF
NEXT J%
IF XOk = 0 THEN GOTO FileBad
'
' Found name in table - get and check the value
'
cv = VAL(sv$): IF cv < rvl(J%) OR cv > rvh(J%) THEN GOTO FileBad
cv(J%) = cv
PRINT rvs$(J%); " - "; : PRINT USING cs$(J%); cv
i% = i% + 1
GOTO Read2ndLoop
'
' Here if starting Banner not found
'
FileEOF1:
PRINT "Unexpected EOF on file "; S$; ". No reload values were found."
ReadOk = 0
ReadExit:
CLOSE #2
PRINT "Hit any key to continue ... "
WaitForKey3:
IF INKEY$ = "" THEN GOTO WaitForKey3
RETURN
'
' Here if EOF before EOF Banner
'
FileEOF2:
PRINT "Unexpected EOF on file "; RFN$; ".";
GOTO ReadDone
'
' Something wrong with entry after the Banner
'
FileBad:
PRINT "Bad format on file "; RFN$; ". Reading terminated, ";
ReadDone:
PRINT i%; "values reloaded."
ReadOk = 1
GOTO ReadExit
END
'
' ON ERROR handling subroutines
'
' FileErr - File not found
'
FileErr:
PRINT "File "; S$; " *NOT* found."
ErrFlag = 1
RESUME NEXT
'
' Here if output file doesn't exists - that's what we expect
'
OpenFileNotFnd:
ErrFlag = 0
RESUME NEXT
'
VTScal:
CLS
LOCATE 2, 17: PRINT "*  *  *  *  Vinduced Voltage at Ts  *  *  *  *"
GOSUB GetVTMT
LOCATE 6, 11: PRINT "Vind(Ts) = "
GOTO Menu1

' Four Quadrent ArcTangent Function
FUNCTION ATN2 (num, denom)
PI = 3.14159265#
IF ABS(denom) < 1E-30 THEN atval = SGN(denom) * PI / 2: GOTO done
atval = ATN(num / denom)
IF denom >= 0 THEN GOTO done
IF num < 0 THEN atval = atval - PI ELSE atval = atval + PI
done:
ATN2 = atval
END FUNCTION

'
' Menu24 - used for Speedy Digrams
'          Handles line 24 menus without scrolling the screen
'
SUB Menu24 (Menu24Arg$, S$)
SHARED bl$, CHCR$, CHBS$
Menu24Start:
	S$ = ""
Menu24Cont:
	LOCATE 24, 1
	PRINT bl$;
	LOCATE 24, 1
	PRINT Menu24Arg$; S$;
'
' Most of this flummery with INKEY$ is to prevent the diagram from
'      scrolling when the final CR is hit since we are working on line 24.
'
Menu24Wait:
	SS$ = INKEY$
	SS$ = UCASE$(SS$)
	SELECT CASE SS$
		CASE ""
			GOTO Menu24Wait
		CASE CHCR$
			EXIT SUB
		CASE CHBS$
			IF LEN(S$) > 0 THEN
				S$ = LEFT$(S$, LEN(S$) - 1)
				GOTO Menu24Cont
			END IF
		CASE IS <= " "
			GOTO Menu24Start
		CASE ELSE
			IF LEN(S$) > 2 THEN
				GOTO Menu24Start
			END IF
			S$ = S$ + SS$
			PRINT SS$;
	END SELECT
	GOTO Menu24Wait
	END SUB

' ROOTS
' Bairstow's Polynomial Root Method
' This routine will find the real and complex roots of an nth degree
' polynomial with real coefficients: P(x) = Ao + A1 x + . . . + An x^n
' P(x) = D5 + C5 x + B5 x^2 + A5 x^3 + x^4
' X is 10^-5 * s
SUB ROOTS (A5, B5, C5, D5)
SHARED ALPH15, W15, ALPH25, W25
DIM A(6), B(6), E(2), S(2), T(2)
E1 = .0001: E4 = 1E-20: K1% = 100
'
' 4th Degree Polynomial
'
N1% = 4: A(1) = 1: A(2) = A5: A(3) = B5: A(4) = C5: A(5) = D5: A(6) = 0
M1% = 1: P = 1: Q = 1
FOR K% = 1 TO K1%
FOR L% = 1 TO K1%
'
' Store all coefficients in array B
'
FOR i% = 1 TO 5: B(i%) = A(i%): NEXT i%
FOR J% = 2 TO 0 STEP -2
FOR i% = 1 TO J% + 1
B(i% + 1) = B(i% + 1) - P * B(i%): B(i% + 2) = B(i% + 2) - Q * B(i%)
NEXT i%: NEXT J%
R0 = B(5): R1 = B(4): S0 = B(3): S1 = B(2)
V0 = -Q * S1: V1 = S0 - S1 * P: D0 = V1 * S0 - V0 * S1
IF ABS(D0) > E4 THEN EXIT FOR
P = P + 5: Q = Q + 5
NEXT L%
D1 = S0 * R1 - S1 * R0: D2 = R0 * V1 - V0 * R1
P1 = D1 / D0: Q1 = D2 / D0
P = P + P1: Q = Q + Q1
IF ABS(R0) >= E1 THEN GOTO L1
IF ABS(R1) >= E1 THEN GOTO L1
E(M1%) = 1
GOTO cont
L1:
IF ABS(P1) >= E1 OR ABS(Q1) >= E1 THEN GOTO L2
E(M1%) = 2
GOTO cont
L2:
IF P = 0 THEN GOTO l3
IF ABS(P1 / P) >= E1 THEN GOTO NextIter
l3:
IF Q = 0 THEN GOTO NextIter
IF ABS(Q1 / Q) >= E1 THEN GOTO NextIter
E(M1%) = 3
GOTO cont
NextIter:
NEXT K%
E(M1%) = 4
cont:
S = -P / 2: T = S * S - Q
IF T < 0 THEN GOTO l5
T = SQR(T)
'
' Probably an error if roots are real pairs not complex conjugate pairs
'        Roots = S +/- T
'
T(M1%) = 0: S(M1%) = S
GOTO l6
l5:
T = SQR(-T)
'
' roots are complex conjugate pairs as we expected
'        Roots = S +/- j * T
'
S(M1%) = S: T(M1%) = T
l6:
IF E(M1%) = 4 THEN GOTO EndRoot
FOR J% = 1 TO 3
A(J% + 1) = A(J% + 1) - P * A(J%): A(J% + 2) = A(J% + 2) - Q * A(J%)
NEXT J%
N1% = N1% - 2
IF N1% < 1 THEN GOTO EndRoot
M1% = M1% + 1: E(M1%) = 1
P = A(2) / A(1): Q = A(3) / A(1)
GOTO cont
EndRoot:
'
' Now sort out alphas and ws
' Solution in the form ALPH +/- jW
' ALPH15 > ALPH25
' W15 > W25
'
IF ABS(S(1)) > ABS(S(2)) THEN
	ALPH15 = S(1)
	ALPH25 = S(2)
ELSE
	ALPH15 = S(2)
	ALPH25 = S(1)
END IF
IF ABS(T(1)) > ABS(T(2)) THEN
	W15 = T(1)
	W25 = T(2)
ELSE
	W15 = T(2)
	W25 = T(1)
END IF
END SUB

SUB Signon (V$)
'
' Print signon msg
'
CLS
PRINT V$
PRINT "Copyright (C) 1987, 1988 - Corum & Associates, Inc."
PRINT "All rights reserved."
PRINT
PRINT "Corum & Associates, Inc."
PRINT "8551 State Route 534"
PRINT "Windsor, OH  44099"
IF internal% THEN
	PRINT
	PRINT "WARNING - This version of TCTUTOR contains internal,"
	PRINT "          undocumented features. Proceed at your own risk!"
END IF
END SUB

